#include <opencl.h>
#include <cl_platform.h>


cl_platform_id * platforms = NULL;
char vendor_name[128] = {0};
cl_uint num_platforms = 0;

cl_uint num_devices=0;


int aaa()
{
   // get number of available platforms
   cl_int err = clGetPlatformIDs(0, NULL, & num_platforms);
   printf("err=%d,num_platforms=%d\n", err, num_platforms );
   if(CL_SUCCESS != err) {
     printf("err!\n");
   }
   platforms = (cl_platform_id*)malloc(sizeof(cl_platform_id)* num_platforms);
   if(NULL == platforms){
     printf("malloc err!\n");
   }
   err = clGetPlatformIDs(num_platforms, platforms, NULL);
   printf("clGetPlatformIDs err=%d platforms[0]=%x\n", err, platforms[0] );
   if(CL_SUCCESS != err){
     printf("clGetPlatformIDs err!\n");
   }
   for (cl_uint ui=0; ui< num_platforms; ++ui){
    printf("platforms[ui]=%x\n", platforms[ui] );
    err = clGetPlatformInfo(platforms[ui], CL_PLATFORM_VENDOR,
                              128*sizeof(char), vendor_name, NULL);
printf("err=%d,vendor_name=%s\n", err, vendor_name );
    if(CL_SUCCESS != err){ printf("error !\n"); }
    err = clGetPlatformInfo(platforms[ui], CL_PLATFORM_NAME,
                              128*sizeof(char), vendor_name, NULL);
printf("err=%d,NAME=%s\n",err, vendor_name  );
    if(CL_SUCCESS != err){ printf("error !\n"); }
    err = clGetPlatformInfo(platforms[ui], CL_PLATFORM_VERSION,
                              128*sizeof(char), vendor_name, NULL);
printf("err=%d,VERSION=%s\n",err, vendor_name  );
    if(CL_SUCCESS != err){ printf("error !\n"); }
    err = clGetPlatformInfo(platforms[ui], CL_PLATFORM_PROFILE,
                              128*sizeof(char), vendor_name, NULL);
printf("err=%d,profile=%s\n",err, vendor_name  );
    if(CL_SUCCESS != err){ printf("error !\n"); }
    err = clGetPlatformInfo(platforms[ui], CL_PLATFORM_EXTENSIONS,
                              128*sizeof(char), vendor_name, NULL);
printf("err=%d,extensions=%s\n",err, vendor_name  );
    if(CL_SUCCESS != err){ printf("error !\n"); }
    if(vendor_name != NULL){
      if(!strcmp(vendor_name, "Intel Corporation")){
         return platforms[ui];
      }
    }
   }
// handle error
}


#define XXX CL_DEVICE_TYPE_ALL
//#define XXX CL_DEVICE_TYPE_DEFAULT
//#define XXX CL_DEVICE_TYPE_ACCELERATOR
//#define XXX CL_DEVICE_TYPE_GPU
//#define XXX CL_DEVICE_TYPE_CPU

cl_device_id device_id = NULL;

dev()
{
 int ret;
 ret = clGetDeviceIDs( platforms[0], XXX,0,NULL, &num_devices);
printf("clGetDeviceIDs err=%d,num_devices=%d\n", ret, num_devices );
 ret = clGetDeviceIDs( platforms[0], XXX,1,&device_id, &num_devices);
printf("clGetDeviceIDs err=%d,num_devices=%d, device_id=%x\n", ret, num_devices, device_id );

}




int main(int argc, char *argv[])
{
 aaa();
 dev();
}


